diff --git a/menu/drivers_display/menu_display_gl.c b/menu/drivers_display/menu_display_gl.c
index 310f629a0af..22dcf3ee69c 100644
--- a/menu/drivers_display/menu_display_gl.c
+++ b/menu/drivers_display/menu_display_gl.c
@@ -23,9 +23,48 @@
 #include "../../gfx/font_driver.h"
 #include "../../gfx/video_driver.h"
 #include "../../gfx/common/gl_common.h"
+#include "../../verbosity.h"
 
 #include "../menu_driver.h"
 
+#if defined(__arm__) || defined(__aarch64__)
+#define MALI_BUG
+#endif
+
+#ifdef MALI_BUG
+static int scInit, scMali4xx, scx0, scx1, scy0, scy1;
+static const struct {
+   const char *str;
+   int len;
+} scDevStr[] = {
+   { "ARM Mali-4xx", 10 },
+   { 0, 0 }
+};
+
+static void scSetRekt(int x0, int x1, int y0, int y1, int sc)
+{
+   const int dx = sc ? 10 : 2;
+   const int dy = dx;
+   scx0 = x0 + dx;
+   scx1 = x1 - dx;
+   scy0 = y0 + dy;
+   scy1 = y1 - dy;
+}
+
+static bool scRekt(int x0, int x1, int y0, int y1)
+{
+   if (x1 < scx0)
+      return true;
+   if (scx1 < x0)
+      return true;
+   if (y1 < scy0)
+      return true;
+   if (scy1 < y0)
+      return true;
+   return false;
+}
+#endif
+
 static const GLfloat gl_vertexes[] = {
    0, 0,
    1, 0,
@@ -79,7 +118,7 @@ static GLenum menu_display_prim_to_gl_enum(
 
 static void menu_display_gl_blend_begin(video_frame_info_t *video_info)
 {
-   gl_t             *gl          = (gl_t*)video_info->userdata;
+   gl_t *gl = (gl_t*)video_info->userdata;
 
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
@@ -103,11 +142,45 @@ static void menu_display_gl_viewport(menu_display_ctx_draw_t *draw,
 static void menu_display_gl_draw(menu_display_ctx_draw_t *draw,
       video_frame_info_t *video_info)
 {
-   gl_t             *gl          = (gl_t*)video_info->userdata;
+#ifdef MALI_BUG
+   int i;
+   const char *gpuDevStr;
+#endif
+   gl_t *gl = (gl_t*)video_info->userdata;
 
    if (!gl || !draw)
       return;
 
+#ifdef MALI_BUG
+   if (!scInit)
+   {
+      scInit = 1;
+      if ((scx0 + scx1 + scy0 + scy1) == 0)
+         scSetRekt(0, video_info->width - 1, 0, video_info->height - 1, 0);
+      gpuDevStr = video_driver_get_gpu_device_string();
+      if (gpuDevStr)
+      {
+         for (i = 0; scDevStr[i].len; ++i)
+         {
+            if (strncmp(gpuDevStr, scDevStr[i].str, scDevStr[i].len) == 0)
+            {
+               scMali4xx = 1;
+               break;
+            }
+         }
+      }
+   }
+   /* discards not only out-of-bounds scissoring, but also out-of-view draws
+      this is intentional */
+   if (scMali4xx &&
+       scRekt(draw->x, draw->x + draw->width - 1, draw->y, draw->y + draw->height - 1))
+   {
+      /*RARCH_WARN("[Menu]: discarded draw rect: %.4i %.4i %.4i %.4i\n",
+         (int)draw->x, (int)draw->y, (int)draw->width, (int)draw->height);*/
+      return;
+   }
+#endif
+
    if (!draw->coords->vertex)
       draw->coords->vertex = menu_display_gl_get_default_vertices();
    if (!draw->coords->tex_coord)
@@ -243,12 +316,18 @@ static void menu_display_gl_scissor_begin(
 {
    glScissor(x, video_info->height - y - height, width, height);
    glEnable(GL_SCISSOR_TEST);
+#ifdef MALI_BUG
+   scSetRekt(x, x + width - 1, y, y + height - 1, 1);
+#endif
 }
 
 static void menu_display_gl_scissor_end(video_frame_info_t *video_info)
 {
    glScissor(0, 0, video_info->width, video_info->height);
    glDisable(GL_SCISSOR_TEST);
+#ifdef MALI_BUG
+   scSetRekt(0, video_info->width - 1, 0, video_info->height - 1, 0);
+#endif
 }
 
 menu_display_ctx_driver_t menu_display_ctx_gl = {
diff --git a/menu/menu_driver.c b/menu/menu_driver.c
index 9de34dfb68b..df05ffce340 100644
--- a/menu/menu_driver.c
+++ b/menu/menu_driver.c
@@ -503,8 +503,28 @@ void menu_display_blend_end(video_frame_info_t *video_info)
 /* Begin scissoring operation */
 void menu_display_scissor_begin(video_frame_info_t *video_info, int x, int y, unsigned width, unsigned height)
 {
+   if (y < 0)
+      y = 0;
+   if (x < 0)
+      x = 0;
+   if (y >= menu_display_framebuf_height)
+      goto skipts;
+   if (x >= menu_display_framebuf_width)
+      goto skipts;
+   if ((y + height) > menu_display_framebuf_height)
+      height = menu_display_framebuf_height - y;
+   if ((x + width) > menu_display_framebuf_width)
+      width = menu_display_framebuf_width - x;
+   if (height <= 0)
+      goto skipts;
+   if (width <= 0)
+      goto skipts;
+
    if (menu_disp && menu_disp->scissor_begin)
       menu_disp->scissor_begin(video_info, x, y, width, height);
+   return;
+skipts:
+   ;/*RARCH_WARN("[Menu]: discard scissor %.4i %.4i %.4u %.4u\n", x, y, width, height);*/
 }
 
 /* End scissoring operation */
@@ -792,9 +812,15 @@ void menu_display_draw(menu_display_ctx_draw_t *draw,
 
    /* TODO - edge case */
    if (draw->height <= 0)
-      draw->height = 1;
+      goto skipts;
+   if (draw->width <= 0)
+      goto skipts;
 
    menu_disp->draw(draw, video_info);
+   return;
+skipts:
+   ;/*RARCH_WARN("[Menu]: discard draw %.4i %.4i %.4i %.4i\n",
+      (int)draw->x, (int)draw->y, (int)draw->width, (int)draw->height);*/
 }
 
 void menu_display_draw_pipeline(menu_display_ctx_draw_t *draw,
